(function() {
	if (window.IEntryJs) return;
	var IEntryJs = {
		IEntryJsClosureMap: { //保存js闭包回调函数
		},
		IEntryJsForNativeMap: { //保存预定义的供原生代码调用的js方法，例如安卓手机中返回按钮的事件可以通过此方式传递给H5.
		},
		callEntryNative: function(name, params, callback) { //js调用原生方法的入口，供H5使用
			try {
				var callTime = new Date().getTime();
				if (callback) this.IEntryJsClosureMap[name + callTime] = callback;
				try {
					params = eval('(' + params + ')');
				} catch(ex) {
					//            alert("convert params error "+ex);
				}
				var paramsObj = {
					methodName: name,
					callTime: callTime + "",
					params: params
				};
				window.location.href = "ientry:callEntryNative/" + JSON.stringify(paramsObj);
			} catch(e) {
				alert(e);
			}
		},
		logNative: function(message) {
			this.callEntryNative("nativeLog", "log from js >>> " + message);
		},
		logError: function(e) {
			this.logNative(e.name + ":" + e.message);
		},
		registerJsForNative: function(name, jsMethod) { //注册专供native代码调用的H5函数
			this.IEntryJsForNativeMap[name] = jsMethod;
		},
		unregisterJsForNative: function(name) { //解除注册专供native代码调用的H5函数
			delete this.IEntryJsForNativeMap[name];
		},
		callEntryJs: function(name, callTime, params) { //专供native代码调用，用以执行对应的js函数
			try {
				var jsMethod = this.IEntryJsForNativeMap[name];
				if (jsMethod) {
					jsMethod(params,
					function(params) {
						var paramsObj = {
							methodName: name,
							callTime: callTime,
							params: params
						};
						window.location.href = "ientry:callEntryNativeCallback/" + JSON.stringify(paramsObj);
					});
				}
			} catch(e) {
				this.logError(e);
			}
		},
		callEntryJsClosure: function(name, callTime, params) {
			//原生方法调用js闭包回调的入口，专供js执行原生代码后原生代码将执行结果传递给js时使用，H5不要使用该方法。
			try {
				var obj = "";
				for (var item in this.IEntryJsClosureMap) {
					obj += item + "\n";
				}
				var closureCallback = this.IEntryJsClosureMap[name + callTime];
				if (closureCallback) {
					closureCallback(params);
					delete this.IEntryJsClosureMap[name + callTime];
				} else {
					this.showToast("未找到js函数" + name + "的回调函数，请确认该函数存在回调函数");
				}
				obj = "";
				for (var item in this.IEntryJsClosureMap) {
					obj += item + "\n";
				}
			} catch(e) {
				this.logError(e);
			}
		}
	};
	window.IEntryJs = IEntryJs;
	(function() {
		try {
			var event = document.createEvent("HTMLEvents");
			event.initEvent("IEntryJsReady", true, false);
			window.dispatchEvent(event);
		} catch(e) {
			alert(e);
		}
	})();
})();